﻿using Prism.Commands;
using Prism.Mvvm;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DontHarmDesktop.ViewModels
{
    public class ServiceEditViewModel : BindableBase
    {
        public string Name { get; set; }
        public decimal Price { get; set; }
        public string Code { get; set; }
        private int ServiceId { get; set; }
        public DelegateCommand Submit { get; set; }
        public DelegateCommand Cancel { get; set; }

        public ServiceEditViewModel(Models.services service)
        {
            Price = service.price;
            Name = service.name;
            Code = service.code;
            ServiceId = service.id;

            Submit = new DelegateCommand(SubmitExecuted);
            Cancel = new DelegateCommand(CancelExecuted);
        }

        private void SubmitExecuted()
        {
            // Валидация
            decimal price = Price;
            List<string> errors = new List<string>();
            bool isValid = Validation.CheckService(Code, price, Name, errors);
            if (!isValid)
            {
                Validation.DisplayErrors(errors);
                return;
            }

            // Обновление объекта
            var db = new DontHarmDesktop.Models.Entities();
            var foundService = db.services.FirstOrDefault(x => x.id == ServiceId);
            foundService.price = price;
            foundService.name = Name;
            foundService.code = Code;
            db.SaveChanges();

            // Переход к списку всех услуг
            Navigation.toServicesList();
        }

        private void CancelExecuted()
        {
            Navigation.toServicesList();
        }
    }
}
